%global debug_package %{nil}

%global pypi_name metrics-utility
%global pkg_name aap-metrics-utility
%global module_name metrics_utility
%global commitId 046c6e2adb87ed5061ab070c6f98ce5a211f8744

%global et_xmlfile_version 1.1.0
%global et_xmlfile_source_dir et_xmlfile-1.1
%global insights_version 0.3.2
%global insights_source_dir python-insights-analytics-collector-26d0b13dd55d53df401a6bfeead8dbaf22a37a1a
%global numpy_version 1.26.4
%global numpy_source_dir python-numpy-9815c16f449e12915ef35a8255329ba26dacd5c0
%global meson_source_dir meson-4e370ca8ab73c07f7b84abe8a4b937caace050a4
%global x86_simd_sort_source_dir x86-simd-sort-0631a88763a4a0a4c9e84d5eeb0ec5d36053730b
%global svml_source_dir svml-1b21e453f6b1ba6a6aca392b1d810d9d41576123
%global openpyxl_version 3.1.2
%global openpyxl_source_dir openpyxl-%{openpyxl_version}
%global pandas_version 2.2.1
%global pandas_commitId bdc79c146c2e32f2cab629be240f01658cfb6cc2
%global pandas_source_dir python-pandas-%{pandas_commitId}

%if 0%{?rhel} >= 9
%global blaslib flexiblas
%global blasvar %{nil}
%else
%global blaslib openblas
%global blasvar p
%endif

%global common_description %{expand:
The AAP metrics utility tool is a standalone CLI utility called metrics-utility which is intended to be installed to the system containing instance of the Automation Controller.
It's an alternative command line tool for the Controller's CLI awx-manage}

%global __requires_exclude ^(/var/lib/awx/venv/awx/bin/python.*|/usr/bin/python.*)

%global awx_venv_root /var/lib/awx/venv/awx
%global awx_venv_sitelib %{awx_venv_root}/lib/python%{python3_version}/site-packages

Name:           %{pkg_name}
Version:        0.1.0
Release:        1%{?dist}
Summary:        Standalone utility for https://github.com/ansible/awx/

License:        Apache-2.0
URL:            https://github.com/ansible/metrics-utility.git
Source0:        metrics-utility-046c6e2adb87ed5061ab070c6f98ce5a211f8744.tar.gz
Source1:        %{et_xmlfile_source_dir}.tar.gz
Source2:        python-insights-analytics-collector-26d0b13dd55d53df401a6bfeead8dbaf22a37a1a.tar.gz
Source3:        python-numpy-9815c16f449e12915ef35a8255329ba26dacd5c0.tar.gz
Source4:        meson-4e370ca8ab73c07f7b84abe8a4b937caace050a4.tar.gz
Source5:        x86-simd-sort-0631a88763a4a0a4c9e84d5eeb0ec5d36053730b.tar.gz
Source6:        svml-1b21e453f6b1ba6a6aca392b1d810d9d41576123.tar.gz
Source7:        %{openpyxl_source_dir}.tar.gz
Source8:        python-pandas-bdc79c146c2e32f2cab629be240f01658cfb6cc2.tar.gz

BuildRequires:  %{blaslib}-devel
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  lapack-devel
BuildRequires:  ninja-build
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-packaging
BuildRequires:  python%{python3_pkgversion}-pip
BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-tomli
BuildRequires:  python%{python3_pkgversion}-wheel

Requires:       automation-controller-venv-tower >= 4.3
Requires:       automation-controller-venv-tower < 4.6
Requires:       tzdata

Provides:       bundled(python%{python3_pkgversion}dist(insights-analytics-collector)) = %{insights_version}
Provides:       bundled(python%{python3_pkgversion}dist(openpyxl)) = %{openpyxl_version}
Provides:       bundled(python%{python3_pkgversion}dist(pandas)) = %{pandas_version}

# indirect dependencies
Provides:       bundled(python%{python3_pkgversion}dist(et-xmlfile)) = %{et_xmlfile_version}
Provides:       bundled(python%{python3_pkgversion}dist(numpy)) = %{numpy_version}

%description
%{common_description}

%prep
%setup -q -T -D -b 1 -n %{et_xmlfile_source_dir}
%setup -q -T -D -b 2 -n %{insights_source_dir}
%setup -q -T -D -b 3 -n %{numpy_source_dir}
tar -C vendored-meson/meson --strip-component=1 -xf %{SOURCE4}
tar -C numpy/core/src/npysort/x86-simd-sort --strip-component=1 -xf %{SOURCE5}
tar -C numpy/core/src/umath/svml --strip-component=1 -xf %{SOURCE6}
%setup -q -T -D -b 7 -n %{openpyxl_source_dir}
%setup -q -T -D -b 8 -n %{pandas_source_dir}
%autosetup -n %{pypi_name}-%{commitId}

# openblas is provided by flexiblas by default; otherwise,
# Use openblas pthreads as recommended by upstream (see comment in site.cfg.example)
cat >> %{_builddir}/%{numpy_source_dir}/site.cfg <<EOF
[openblas]
libraries = %{blaslib}%{blasvar}
library_dirs = %{_libdir}
EOF

pushd %{_builddir}/%{pandas_source_dir}
  sed -i '/tzdata>=2022.7/d' pyproject.toml
  echo '__version__="%{pandas_version}"' > _version_meson.py
  echo '__git_version__="%{pandas_commitId}"' >> _version_meson.py
popd

# documentation and license
mkdir -p venv_files/{documentation,licenses}/{et-xmlfile,insights-analytics-collector,numpy,openpyxl,pandas}
pushd venv_files
  cp %{_builddir}/%{et_xmlfile_source_dir}/README.rst documentation/et-xmlfile/
  cp %{_builddir}/%{et_xmlfile_source_dir}/LICENCE.rst licenses/et-xmlfile/

  cp %{_builddir}/%{insights_source_dir}/CHANGELOG.md %{_builddir}/%{insights_source_dir}/README.md documentation/insights-analytics-collector/
  cp %{_builddir}/%{insights_source_dir}/LICENSE.md licenses/insights-analytics-collector/

  cp %{_builddir}/%{numpy_source_dir}/README.md documentation/numpy/
  cp %{_builddir}/%{numpy_source_dir}/LICENSE.txt licenses/numpy/

  cp %{_builddir}/%{openpyxl_source_dir}/README.rst documentation/openpyxl/
  cp %{_builddir}/%{openpyxl_source_dir}/LICENCE.rst licenses/openpyxl/

  cp %{_builddir}/%{pandas_source_dir}/README.md documentation/pandas/
  cp %{_builddir}/%{pandas_source_dir}/LICENSE licenses/pandas/
popd

%build
%{__python3} -m pip config set global.index https://repository.engineering.redhat.com/nexus/repository/pypi.org/pypi
%{__python3} -m pip config set global.index_url https://repository.engineering.redhat.com/nexus/repository/pypi.org/simple
%{__python3} -m pip config set global.trusted-host repository.engineering.redhat.com

%{__python3} -m pip install setuptools==65.5.1
%{__python3} -m pip install Cython==3.0.5 numpy==%{numpy_version} pyproject-metadata==0.7.1 versioneer[toml]==0.29 meson-python==0.15.0 meson==1.2.1

export PATH=~/.local/bin:$PATH
build_wheel='%{__python3} -m pip wheel --wheel-dir %{_builddir}/wheeldir --no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --no-clean --progress-bar off --verbose .'

# metrics utility
${build_wheel}

pushd %{_builddir}/%{et_xmlfile_source_dir}
  ${build_wheel}
popd

pushd %{_builddir}/%{insights_source_dir}
  ${build_wheel}
popd

pushd %{_builddir}/%{numpy_source_dir}
  OPENBLAS=%{_libdir} \
  BLAS=%{_libdir} \
  LAPACK=%{_libdir} CFLAGS="%{optflags}" \
  ${build_wheel}
popd

pushd %{_builddir}/%{openpyxl_source_dir}
  ${build_wheel}
popd

pushd %{_builddir}/%{pandas_source_dir}
  ${build_wheel}
popd

%install

function install_wheel {
  pypi_name=$1
  version=$2
  module_name=${4:-$1}
  if [[ $3 == "lib" ]]; then sitelib_path=%{buildroot}/%{python3_sitelib}; else sitelib_path=%{buildroot}/%{python3_sitearch}; fi
  %{__python3} -m pip install --root %{buildroot} --no-deps --disable-pip-version-check --progress-bar off --verbose --ignore-installed --no-warn-script-location --no-index --no-cache-dir --find-links %{_builddir}/wheeldir ${pypi_name}==${version}
  sed -i 's/pip/rpm/' ${sitelib_path}/${module_name}-${version}.dist-info/INSTALLER
  rm -fv ${sitelib_path}/${module_name}-${version}.dist-info/{RECORD,REQUESTED}
  mv ${sitelib_path}/${module_name}* %{buildroot}/%{awx_venv_sitelib}/
}

mkdir -p %{buildroot}/%{awx_venv_sitelib}

# metrics utility
install_wheel %{pypi_name} %{version} lib %{module_name}

PYTHON_INTERPRETER='#!/var/lib/awx/venv/awx/bin/python'
sed -i "1 s|^.*$|$PYTHON_INTERPRETER|" %{buildroot}/%{_bindir}/%{pypi_name}

pushd %{_builddir}/%{et_xmlfile_source_dir}
  install_wheel et-xmlfile %{et_xmlfile_version} lib et_xmlfile
popd

pushd %{_builddir}/%{insights_source_dir}
  install_wheel insights-analytics-collector %{insights_version} lib insights_analytics_collector
  rm -rf %{buildroot}/%{python3_sitelib}/tests
popd

pushd %{_builddir}/%{numpy_source_dir}
  OPENBLAS=%{_libdir} \
  FFTW=%{_libdir} BLAS=%{_libdir} \
  LAPACK=%{_libdir} CFLAGS="%{optflags}" \
  install_wheel numpy %{numpy_version} lib64
popd

pushd %{_builddir}/%{openpyxl_source_dir}
  install_wheel openpyxl %{openpyxl_version} lib
popd

pushd %{_builddir}/%{pandas_source_dir}
  install_wheel pandas %{pandas_version} lib64
popd

%files
%doc CHANGELOG.md README.md
%license LICENSE.md
%{_bindir}/%{pypi_name}
%{awx_venv_sitelib}/%{module_name}
%{awx_venv_sitelib}/%{module_name}-%{version}.dist-info

%{awx_venv_sitelib}/et_xmlfile
%{awx_venv_sitelib}/et_xmlfile-%{et_xmlfile_version}.dist-info

%{awx_venv_sitelib}/insights_analytics_collector
%{awx_venv_sitelib}/insights_analytics_collector-%{insights_version}.dist-info

%exclude %{_bindir}/f2py
%{awx_venv_sitelib}/numpy
%{awx_venv_sitelib}/numpy-%{numpy_version}.dist-info

%{awx_venv_sitelib}/openpyxl
%{awx_venv_sitelib}/openpyxl-%{openpyxl_version}.dist-info

%{awx_venv_sitelib}/pandas
%{awx_venv_sitelib}/pandas-%{pandas_version}.dist-info

%doc venv_files/documentation/*
%license venv_files/licenses/*

%changelog
* Mon Mar 11 2024 Satoe Imaishi <simaishi@redhat.com> 0.1.0-1
- Update to 0.1.0

* Tue Oct 03 2023 Satoe Imaishi <simaishi@redhat.com> 0.0.1-2
- Bump controller version upper constraint to < 4.6

* Wed Jun 28 2023 James Marshall <jamarsha@redhat.com> 0.0.1-1
- Initial release
